"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dependency_injection_1 = require("@typemon/dependency-injection");
//
const metadata_key_1 = require("./metadata-key");
//
//
//
function Controller(options = {}) {
    return (target) => {
        const constructor = dependency_injection_1.TargetHandle.targetify(target);
        const targetHandle = dependency_injection_1.TargetHandle.create(constructor);
        if (targetHandle.hasMetadata(metadata_key_1.MetadataKey.ControllerMetadata)) {
            throw new Error(`Decorator 'Controller' can not be duplicated.`);
        }
        const metadata = {
            options
        };
        targetHandle.setMetadata(metadata_key_1.MetadataKey.ControllerMetadata, metadata);
    };
}
exports.Controller = Controller;
