import { Provider } from '@typemon/dependency-injection';
import { Middleware } from './middleware';
export declare function Handler(options?: Handler.Options): MethodDecorator;
export declare namespace Handler {
    interface Options {
        /**
         * @default KebabCase.convert(propertyKey)
         */
        readonly name?: string;
        /**
         * @default true
         */
        readonly useAPIGateway?: boolean;
        /**
         * @default 200
         */
        readonly statusCode?: number;
        readonly headers?: Readonly<Record<string, string>>;
        readonly providers?: ReadonlyArray<Provider>;
        readonly middlewares?: ReadonlyArray<Middleware.Constructor | Middleware.WithProviders>;
    }
    interface Metadata {
        readonly propertyKey: string;
        readonly options: Options;
    }
}
