import { Provider } from '@typemon/dependency-injection';
export interface Middleware {
    handler(...parameters: Array<any>): void | Promise<void>;
}
export declare function Middleware(options?: Middleware.Options): ClassDecorator;
export declare namespace Middleware {
    interface Options {
        readonly providers?: ReadonlyArray<Provider>;
    }
    interface Metadata {
        readonly options: Options;
    }
    type Constructor = new (...parameters: Array<any>) => Middleware;
    class WithProviders {
        readonly target: Constructor;
        readonly providers: ReadonlyArray<Provider>;
        static isWithProviders(value: unknown): value is WithProviders;
        static create(target: Constructor, providers: ReadonlyArray<Provider>): WithProviders;
        constructor(target: Constructor, providers: ReadonlyArray<Provider>);
    }
}
