"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dependency_injection_1 = require("@typemon/dependency-injection");
//
const metadata_key_1 = require("./metadata-key");
function Middleware(options = {}) {
    return (target) => {
        const constructor = dependency_injection_1.TargetHandle.targetify(target);
        const targetHandle = dependency_injection_1.TargetHandle.create(constructor);
        if (targetHandle.hasMetadata(metadata_key_1.MetadataKey.MiddlewareMetadata)) {
            throw new Error(`Decorator 'Middleware' can not be duplicated.`);
        }
        const metadata = {
            options
        };
        targetHandle.setMetadata(metadata_key_1.MetadataKey.MiddlewareMetadata, metadata);
    };
}
exports.Middleware = Middleware;
(function (Middleware) {
    class WithProviders {
        constructor(target, providers) {
            this.target = target;
            this.providers = providers;
        }
        static isWithProviders(value) {
            return value instanceof WithProviders;
        }
        static create(target, providers) {
            return new WithProviders(target, providers);
        }
    }
    Middleware.WithProviders = WithProviders;
})(Middleware = exports.Middleware || (exports.Middleware = {}));
