"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dependency_injection_1 = require("@typemon/dependency-injection");
const check_1 = require("@typemon/check");
//
const parameter_token_1 = require("../../parameter-token");
function Headers() {
    return (target, propertyKey, index) => {
        if (check_1.Check.isUndefined(propertyKey)) {
            throw new Error(`Decorator 'Headers' can not be used in the constructor.`);
        }
        if (check_1.Check.isSymbol(propertyKey)) {
            throw new Error(`Decorator 'Headers' can not be used for symbol properties.`);
        }
        dependency_injection_1.Inject.decorate(parameter_token_1.ParameterToken.HEADERS, target, propertyKey, index);
    };
}
exports.Headers = Headers;
