"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dependency_injection_1 = require("@typemon/dependency-injection");
const check_1 = require("@typemon/check");
//
const metadata_key_1 = require("../../metadata-key");
const parameter_token_1 = require("../../parameter-token");
function QueryParameter(key) {
    return (target, propertyKey, index) => {
        if (check_1.Check.isUndefined(propertyKey)) {
            throw new Error(`Decorator 'QueryParameter' can not be used in the constructor.`);
        }
        if (check_1.Check.isSymbol(propertyKey)) {
            throw new Error(`Decorator 'QueryParameter' can not be used for symbol properties.`);
        }
        dependency_injection_1.Inject.decorate(parameter_token_1.ParameterToken.QUERY_PARAMETER, target, propertyKey, index);
        const constructor = dependency_injection_1.TargetHandle.targetify(target, propertyKey);
        const targetHandle = dependency_injection_1.TargetHandle.create(constructor);
        const metadata = targetHandle.getParameterMetadata(index, propertyKey);
        metadata.set(metadata_key_1.MetadataKey.ParameterKey, key);
    };
}
exports.QueryParameter = QueryParameter;
