"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dependency_injection_1 = require("@typemon/dependency-injection");
const check_1 = require("@typemon/check");
//
const http_request_1 = require("../http-request");
function Request() {
    return (target, propertyKey, index) => {
        if (check_1.Check.isUndefined(propertyKey)) {
            throw new Error(`Decorator 'Request' can not be used in the constructor.`);
        }
        if (check_1.Check.isSymbol(propertyKey)) {
            throw new Error(`Decorator 'Request' can not be used for symbol properties.`);
        }
        dependency_injection_1.Inject.decorate(http_request_1.HttpRequest, target, propertyKey, index);
    };
}
exports.Request = Request;
