"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dependency_injection_1 = require("@typemon/dependency-injection");
const check_1 = require("@typemon/check");
//
const parameter_token_1 = require("../../parameter-token");
const http_response_1 = require("../http-response");
function Response() {
    return (target, propertyKey, index) => {
        if (check_1.Check.isUndefined(propertyKey)) {
            throw new Error(`Decorator 'Response' can not be used in the constructor.`);
        }
        if (check_1.Check.isSymbol(propertyKey)) {
            throw new Error(`Decorator 'Response' can not be used for symbol properties.`);
        }
        dependency_injection_1.Inject.decorate(http_response_1.HttpResponse, target, propertyKey, index);
    };
}
exports.Response = Response;
(function (Response) {
    function Headers() {
        return (target, propertyKey, index) => {
            if (check_1.Check.isUndefined(propertyKey)) {
                throw new Error(`Decorator 'Response.Headers' can not be used in the constructor.`);
            }
            if (check_1.Check.isSymbol(propertyKey)) {
                throw new Error(`Decorator 'Response.Headers' can not be used for symbol properties.`);
            }
            dependency_injection_1.Inject.decorate(parameter_token_1.ParameterToken.RESPONSE_HEADERS, target, propertyKey, index);
        };
    }
    Response.Headers = Headers;
})(Response = exports.Response || (exports.Response = {}));
