export declare class HttpHeaders implements Iterable<[string, string]> {
    private readonly map;
    constructor(headers?: Readonly<Record<string, string>>);
    private getKey;
    [Symbol.iterator](): Iterator<[string, string]>;
    has(name: string): boolean;
    hasNot(name: string): boolean;
    get(name: string): string;
    set(name: string, value: string | ReadonlyArray<string>): void;
    append(name: string, value: string | ReadonlyArray<string>): void;
    delete(name: string): void;
    deleteAll(names?: Iterable<string>): void;
}
export interface ReadonlyHttpHeaders extends Iterable<[string, string]> {
    has(name: string): boolean;
    hasNot(name: string): boolean;
    get(name: string): string;
}
