"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const check_1 = require("@typemon/check");
//
//
//
class HttpParameters {
    constructor(parameters = {}) {
        this.map = new Map();
        for (const [key, value] of Object.entries(parameters)) {
            this.set(key, value);
        }
    }
    has(key) {
        const has = this.map.has(key);
        return has;
    }
    hasNot(key) {
        const has = this.has(key);
        const hasNot = check_1.Check.isFalse(has);
        return hasNot;
    }
    get(key) {
        if (this.hasNot(key)) {
            throw new Error(`Key '${key}' does not exist.`);
        }
        const value = this.map.get(key);
        return value;
    }
    set(key, value) {
        this.map.set(key, value);
    }
    delete(key) {
        this.map.delete(key);
    }
    deleteAll(keys = this.map.keys()) {
        for (const key of keys) {
            this.delete(key);
        }
    }
}
exports.HttpParameters = HttpParameters;
