import { Provider } from '@typemon/dependency-injection';
import { APIGatewayEvent } from 'aws-lambda';
import { Event } from '../event';
import { HttpSharedContext } from './http-shared-context';
import { ReadonlyHttpHeaders } from './http-headers';
import { ReadonlyHttpParameters } from './http-parameters';
export declare class HttpRequest<Body = any> {
    readonly sharedContext: HttpSharedContext;
    private readonly event;
    static readonly PROVIDER: Provider;
    readonly headers: ReadonlyHttpHeaders;
    readonly pathParameters: ReadonlyHttpParameters;
    readonly queryStringParameters: ReadonlyHttpParameters;
    readonly body: Body;
    constructor(sharedContext: HttpSharedContext, event: Event<APIGatewayEvent>);
    readonly method: string;
    readonly path: string;
}
