"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var HttpRequest_1;
Object.defineProperty(exports, "__esModule", { value: true });
"use strict";
const dependency_injection_1 = require("@typemon/dependency-injection");
const check_1 = require("@typemon/check");
//
const parameter_token_1 = require("../parameter-token");
const event_1 = require("../event");
const http_shared_context_1 = require("./http-shared-context");
const http_headers_1 = require("./http-headers");
const http_parameters_1 = require("./http-parameters");
//
//
//
let HttpRequest = HttpRequest_1 = class HttpRequest {
    constructor(sharedContext, event) {
        this.sharedContext = sharedContext;
        this.event = event;
        this.headers = new http_headers_1.HttpHeaders(this.event.headers);
        this.pathParameters = new http_parameters_1.HttpParameters(this.event.pathParameters || {});
        this.queryStringParameters = new http_parameters_1.HttpParameters(this.event.queryStringParameters || {});
        this.body = check_1.Check.isString(this.event.body)
            ? JSON.parse(this.event.body)
            : null;
    }
    get method() {
        return this.event.httpMethod;
    }
    get path() {
        return this.event.path;
    }
};
HttpRequest.PROVIDER = {
    identifier: HttpRequest_1,
    useClass: HttpRequest_1,
    lifetime: dependency_injection_1.Lifetime.Singleton
};
HttpRequest = HttpRequest_1 = __decorate([
    dependency_injection_1.Injectable(),
    __param(1, dependency_injection_1.Inject(parameter_token_1.ParameterToken.EVENT)),
    __metadata("design:paramtypes", [http_shared_context_1.HttpSharedContext, Object])
], HttpRequest);
exports.HttpRequest = HttpRequest;
