import { Provider } from '@typemon/dependency-injection';
import { HttpSharedContext } from './http-shared-context';
import { HttpHeaders, ReadonlyHttpHeaders } from './http-headers';
export declare class HttpResponse {
    readonly sharedContext: HttpSharedContext;
    static readonly PROVIDER: Provider;
    /**
     * @default 200
     */
    statusCode: number;
    readonly headers: HttpHeaders;
    /**
     * @default null
     */
    body: any;
    constructor(sharedContext: HttpSharedContext);
}
export declare namespace HttpResponse {
    interface Serialized {
        readonly statusCode: number;
        readonly headers: Readonly<Record<string, string>>;
        readonly body: string;
    }
    function serialize({ statusCode, headers, body }: {
        readonly statusCode: number;
        readonly headers: Readonly<Record<string, string>> | ReadonlyHttpHeaders;
        readonly body: unknown;
    }): Serialized;
}
