"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var HttpResponse_1;
Object.defineProperty(exports, "__esModule", { value: true });
"use strict";
const dependency_injection_1 = require("@typemon/dependency-injection");
const check_1 = require("@typemon/check");
//
const http_shared_context_1 = require("./http-shared-context");
const http_headers_1 = require("./http-headers");
//
//
//
let HttpResponse = HttpResponse_1 = class HttpResponse {
    constructor(sharedContext) {
        this.sharedContext = sharedContext;
        this.statusCode = 200;
        this.headers = new http_headers_1.HttpHeaders();
        this.body = null;
    }
};
HttpResponse.PROVIDER = {
    identifier: HttpResponse_1,
    useClass: HttpResponse_1,
    lifetime: dependency_injection_1.Lifetime.Singleton
};
HttpResponse = HttpResponse_1 = __decorate([
    dependency_injection_1.Injectable(),
    __metadata("design:paramtypes", [http_shared_context_1.HttpSharedContext])
], HttpResponse);
exports.HttpResponse = HttpResponse;
(function (HttpResponse) {
    function serialize({ statusCode, headers, body }) {
        const serializedHeaders = {};
        const headerEntries = headers instanceof http_headers_1.HttpHeaders
            ? headers
            : Object.entries(headers);
        for (const [name, value] of headerEntries) {
            serializedHeaders[name] = value;
        }
        const serializedBody = check_1.Check.isNotEmpty(body)
            ? check_1.Check.isString(body)
                ? body
                : JSON.stringify(body)
            : '';
        const serializedResponse = {
            statusCode,
            headers: serializedHeaders,
            body: serializedBody
        };
        return serializedResponse;
    }
    HttpResponse.serialize = serialize;
})(HttpResponse = exports.HttpResponse || (exports.HttpResponse = {}));
exports.HttpResponse = HttpResponse;
